## linglong 1.9.13

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.11.4)

project(
  linglong
  VERSION 1.10.0
  DESCRIPTION "a container based application package manager for Linux desktop"
  HOMEPAGE_URL "https://github.com/OpenAtom-Linyaps/linyaps"
  LANGUAGES CXX C)

set(LINGLONG_VERSION
    ""
    CACHE STRING "The version of linglong project.")

if(NOT ("${LINGLONG_VERSION}" STREQUAL ""))
  message(STATUS "Project version has been overridden to ${LINGLONG_VERSION}")
  set(PROJECT_VERSION ${LINGLONG_VERSION})
endif()

set(ENABLE_LINGLONG_APP_BUILDER_UTILS
    OFF
    CACHE BOOL "enable build ll-builder-utils to linglong app")

set(BUILD_LINGLONG_BUILDER_UTILS_IN_BOX
    OFF
    CACHE BOOL "build ll-builder-utils in box")

set(ENABLE_LINGLONG_INSTALLER
    OFF
    CACHE BOOL "enable linglong installer")

set(ENABLE_TESTING
    ON
    CACHE BOOL "enable testing")

set(LINGLONG_USERNAME
    "deepin-linglong"
    CACHE STRING "The username for linglong package manager")
set(LINGLONG_ROOT
    "/var/lib/linglong"
    CACHE STRING "The location where linglong related program puts their data")
set(LINGLONG_DEFAULT_OCI_RUNTIME
    "ll-box"
    CACHE STRING "The oci runtime which linglong use by default")

set(LINGLONG_CLI_BIN
    "ll-cli"
    CACHE STRING "The client of package management.")
set(GETTEXT_DOMAIN_NAME
    "linyaps"
    CACHE STRING "The name of gettext domain.")
set(QT_VERSION_MAJOR CACHE STRING "The major version of qt.")
set(LINGLONG_EXPORT_PATH
    "share"
    CACHE STRING
          "The path to export linglong config files, it must end with share.")

if(NOT LINGLONG_EXPORT_PATH MATCHES ".*share$")
  message(
    WARNING
      "LINGLONG_EXPORT_PATH '${LINGLONG_EXPORT_PATH}' must end with 'share'")
  set(LINGLONG_EXPORT_PATH "share")
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include(PFL)

set(ENABLE_CPM YES)

if(CMAKE_VERSION VERSION_LESS "3.14")
  set(ENABLE_CPM NO)
  message(
    STATUS "cmake version ${CMAKE_VERSION} not compatible with CPM.cmake.")
endif()

if(CPM_LOCAL_PACKAGES_ONLY)
  set(ENABLE_CPM NO)
endif()

if(ENABLE_CPM)
  include(CPM)
  CPMFindPackage(
    NAME tl-expected
    VERSION 1.0.0 # NOTE: Upstream cmake version doesn't match git tag, we need
                  # https://github.com/TartanLlama/expected/pull/62 in v1.1.0,
                  # but cmake version of v1.1.0 is 1.0.0.
    GITHUB_REPOSITORY TartanLlama/expected
    GIT_TAG v1.1.0
    GIT_SHALLOW ON
    OPTIONS "EXPECTED_BUILD_TESTS OFF"
    EXCLUDE_FROM_ALL ON)
  CPMFindPackage(
    NAME yaml-cpp
    VERSION 0.6.2
    GITHUB_REPOSITORY jbeder/yaml-cpp
    GIT_TAG 0.8.0 # NOTE: When use this project with CPM.cmake(FetchContent), we
                  # need https://github.com/jbeder/yaml-cpp/pull/583 in v0.8.0
    EXCLUDE_FROM_ALL ON
    OPTIONS "YAML_CPP_INSTALL ON" "YAML_CPP_BUILD_TESTS OFF")
  CPMFindPackage(
    NAME nlohmann_json
    VERSION 3.5.0
    URL "https://github.com/nlohmann/json/archive/refs/tags/v3.5.0.tar.gz"
    EXCLUDE_FROM_ALL ON
    OPTIONS "JSON_BuildTests OFF")
  CPMFindPackage(
    NAME CLI11
    VERSION 2.4.1
    GITHUB_REPOSITORY CLIUtils/CLI11
    GIT_TAG v2.4.1
    EXCLUDE_FROM_ALL ON
    OPTIONS "CLI11_BUILD_TESTS OFF")

  if(ENABLE_TESTING)
    include(CTest)
    CPMFindPackage(
      NAME googletest
      GITHUB_REPOSITORY google/googletest
      GIT_TAG v1.14.0
      VERSION 1.12.1
      OPTIONS "INSTALL_GTEST OFF" "gtest_force_shared_crt"
      FIND_PACKAGE_ARGUMENTS "NAMES GTest"
      GIT_SHALLOW ON
      EXCLUDE_FROM_ALL ON)
  endif()
endif()

set(linglong_EXTERNALS "ytj ytj::ytj")

if(CMAKE_SYSTEM_PROCESSOR MATCHES "^mips" OR CMAKE_SYSTEM_PROCESSOR MATCHES
                                             "^MIPS")
  message(
    STATUS
      "MIPS architecture detected. Globally adding -mxgot to CMAKE_CXX_FLAGS.")

  set(CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -mxgot"
      CACHE STRING "C++ compiler flags" FORCE)
endif()

find_package(fmt 5.2.1 QUIET)
if(NOT fmt_FOUND)
  message(STATUS "system fmt not found, using external fmt")
  add_library(fmt-lib INTERFACE)
  add_library(fmt::fmt ALIAS fmt-lib)
  target_include_directories(fmt-lib INTERFACE external/fmt/include)
endif()

# NOTE: UOS v20 do not have tl-expected packaged.
find_package(tl-expected 1.1.0 QUIET)
if(NOT tl-expected_FOUND)
  message(STATUS "tl-expected not found, using external tl-expected")
  # list(APPEND linglong_EXTERNALS tl-expected) # tl-expected requires 3.14
  add_library(tl-expected INTERFACE)
  add_library(tl::expected ALIAS tl-expected)
  target_include_directories(tl-expected
                             INTERFACE ./external/tl-expected/include)
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake.external)
endif()

find_package(nlohmann_json 3.5.0 QUIET)
if(NOT nlohmann_json_FOUND)
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake.fix)
  find_package(nlohmann_json 3.5.0 REQUIRED)
endif()

# NOTE: UOS v20 do not have cli11 packaged.
find_package(CLI11 2.4.1 QUIET)
if(NOT CLI11_FOUND)
  message(STATUS "CLI11 not found, using external CLI11")
  add_library(CLI11 INTERFACE)
  add_library(CLI11::CLI11 ALIAS CLI11)
  target_include_directories(CLI11 INTERFACE ./external/CLI11)
endif()

find_package(PkgConfig REQUIRED)

if(ENABLE_TESTING)
  pkg_search_module(CRYPTO REQUIRED IMPORTED_TARGET libcrypto)
  find_package(GTest REQUIRED)

  # compatible with old gtest
  if(NOT TARGET GTest::gmock)
    message(STATUS "GTest::gmock not found, alias GTest::gtest")
    add_library(GTest::gmock ALIAS GTest::GTest) # available since 3.5
  endif()
endif()

function(get_real_target_name output target)
  get_target_property("${output}" "${target}" ALIASED_TARGET)
  if("${output}" STREQUAL "")
    set("${output}" "${target}")
  endif()
  set("${output}"
      ${${output}}
      PARENT_SCOPE)
endfunction()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(GNUInstallDirs)
# depends on GNUInstallDirs
configure_file(configure.h.in ${CMAKE_CURRENT_BINARY_DIR}/configure.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# build ll-build-utils only
if(BUILD_LINGLONG_BUILDER_UTILS_IN_BOX)
  pfl_init(AUTO)
  pfl_add_libraries(
    LIBS
    api
    ocppi
    oci-cfg-generators
    APPS
    ll-builder-utils
    uab)
  return()
endif()

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# NOTE(black_desk): Qt keywords conflict with glib.
add_definitions("-DQT_NO_KEYWORDS")

# NOTE(black_desk): Enable Qt logging with context.
add_definitions("-DQT_MESSAGELOGCONTEXT")

# FIXME: can not start container since the kernel does not support the
# CLONE_NEWUSER feature in the chroot environment, reference:
# https://man7.org/linux/man-pages/man2/unshare.2.html. so we skip font cache
# generator by LINGLONG_FONT_CACHE_GENERATOR, it can be removed when the above
# problem is solved.
set(ENABLE_FONT_CACHE_GENERATOR
    OFF
    CACHE BOOL "enable font cache generator")

if(ENABLE_FONT_CACHE_GENERATOR)
  add_definitions(-DLINGLONG_FONT_CACHE_GENERATOR)
endif()

# we need support Qt 5 versions older than 5.15
# https://doc.qt.io/qt-6/cmake-qt5-and-qt6-compatibility.html#supporting-qt-5-versions-older-than-5-15
if(${QT_VERSION_MAJOR})
  message(STATUS "trying specified Qt version: ${QT_VERSION_MAJOR}")
  find_package(
    Qt${QT_VERSION_MAJOR}
    COMPONENTS Core DBus
    REQUIRED)
else()
  message(STATUS "resolving Qt version automatically")

  while(true)
    find_package(Qt6 COMPONENTS Core DBus)
    if(Qt6_FOUND)
      set(QT_VERSION_MAJOR "6")
      break()
    endif()

    find_package(Qt5 COMPONENTS Core DBus)
    if(Qt5_FOUND)
      set(QT_VERSION_MAJOR "5")
      break()
    endif()

    message(FATAL_ERROR "Qt not found")
  endwhile()
endif()

message(STATUS "compiling with Qt${QT_VERSION_MAJOR}")

pkg_search_module(glib2 REQUIRED IMPORTED_TARGET glib-2.0)
pkg_search_module(ostree1 REQUIRED IMPORTED_TARGET ostree-1)
pkg_search_module(systemd REQUIRED IMPORTED_TARGET libsystemd)
pkg_search_module(ELF REQUIRED IMPORTED_TARGET libelf)

set(ytj_ENABLE_TESTING NO)
set(ytj_ENABLE_INSTALL NO)

pfl_init(AUTO)

add_subdirectory(external/http)

pfl_add_libraries(
  LIBS
  api
  dbus-api
  utils
  ocppi
  linglong
  oci-cfg-generators
  APPS
  ll-init
  ll-dialog
  ll-builder
  ll-cli
  ll-package-manager
  llpkg
  ll-session-helper)

if(ENABLE_LINGLONG_APP_BUILDER_UTILS)
  add_subdirectory(apps/ll-builder-utils)
endif()

add_subdirectory(misc)
add_subdirectory(po)

=== misc/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

include(GNUInstallDirs)

function(configure_files)
  foreach(input ${ARGV})
    configure_file(${input} ${input} @ONLY)
  endforeach()
endfunction()

configure_files(
  # find -regex '\.\/\(script\|share\|lib\|libexec\)\/.*' -type f -printf '%P\n'
  # | sort
  libexec/linglong/app-conf-generator
  libexec/linglong/builder/helper/config-check.sh
  libexec/linglong/builder/helper/ldd-check.sh
  libexec/linglong/builder/helper/main-check.sh
  libexec/linglong/builder/helper/symbols-strip.sh
  libexec/linglong/dialog/99-linglong-permission
  libexec/linglong/fetch-archive-source
  libexec/linglong/fetch-dsc-source
  libexec/linglong/fetch-file-source
  libexec/linglong/fetch-git-source
  libexec/linglong/font-cache-generator
  libexec/linglong/ld-cache-generator
  lib/linglong/container/README.md
  lib/linglong/generate-xdg-data-dirs.sh
  lib/systemd/system-environment-generators/61-linglong
  lib/systemd/system/org.deepin.linglong.PackageManager.service
  lib/systemd/system-preset/91-linglong.preset
  lib/systemd/user-generators/linglong-user-systemd-generator
  lib/systemd/user/linglong-session-helper.service
  lib/sysusers.d/linglong.conf
  lib/tmpfiles.d/linglong.conf
  script/linglong.sh
  share/bash-completion/completions/ll-builder
  share/bash-completion/completions/ll-cli
  share/zsh/vendor-completions/_ll-cli
  share/dbus-1/system.d/org.deepin.linglong.PackageManager1.conf
  share/dbus-1/system-services/org.deepin.linglong.PackageManager1.service
  share/linglong/export-dirs.json
  share/linglong/builder/templates/example.yaml
  share/linglong/builder/uab/blacklist
  share/linglong/config.yaml
  share/mime/packages/vnd.linyaps.uab.xml
  share/polkit-1/actions/org.deepin.linglong.PackageManager1.policy
  share/icons/linyaps.svg
  share/applications/linyaps.desktop)

# bash-completion
set(BASH_COMPLETIONS_DIR ${CMAKE_INSTALL_DATADIR}/bash-completion)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/share/bash-completion/completions
        DESTINATION ${BASH_COMPLETIONS_DIR})

# zsh-completion
set(ZSH_COMPLETIONS_DIR ${CMAKE_INSTALL_DATADIR}/zsh)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/share/zsh/vendor-completions
        DESTINATION ${ZSH_COMPLETIONS_DIR})

# dbus
set(DBUS_SYSTEM_BUS_DIR ${CMAKE_INSTALL_DATADIR}/dbus-1)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/share/dbus-1/system.d
        DESTINATION ${DBUS_SYSTEM_BUS_DIR})
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/share/dbus-1/system-services
        DESTINATION ${DBUS_SYSTEM_BUS_DIR})

# libexec
set(LIBEXEC_LINGLONG_DIR ${CMAKE_INSTALL_FULL_LIBEXECDIR}/linglong)
install(
  PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/app-conf-generator
           ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/ld-cache-generator
           ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/font-cache-generator
           ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/fetch-archive-source
           ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/fetch-dsc-source
           ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/fetch-file-source
           ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/fetch-git-source
  DESTINATION ${LIBEXEC_LINGLONG_DIR})

set(LINGLONG_DIALOG_DIR ${LIBEXEC_LINGLONG_DIR}/dialog)
install(
  PROGRAMS
    ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/dialog/99-linglong-permission
  DESTINATION ${LINGLONG_DIALOG_DIR})

# builder helpers
set(LIBEXEC_LINGLONG_BUILDER_DIR ${LIBEXEC_LINGLONG_DIR}/builder)
install(
  PROGRAMS
    ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/builder/helper/config-check.sh
    ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/builder/helper/ldd-check.sh
    ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/builder/helper/main-check.sh
    ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/builder/helper/symbols-strip.sh
  DESTINATION ${LIBEXEC_LINGLONG_BUILDER_DIR}/helper)

# linglong
install(
  PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/lib/linglong/generate-xdg-data-dirs.sh
  DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/linglong)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lib/linglong/container/README.md
        DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/linglong/container)

# linglong default configuration
install(FILES ${CMAKE_CURRENT_LIST_DIR}/share/linglong/config.yaml
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/linglong)

# builder export dirs
install(FILES ${CMAKE_CURRENT_LIST_DIR}/share/linglong/export-dirs.json
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/linglong)

# builder templates
install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/share/linglong/builder/templates/
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/linglong/builder/templates)
install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/share/linglong/builder/uab/
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/linglong/builder/uab)

# systemd
set(SYSTEMD_SYSTEM_PRESET_PATH
    ${CMAKE_INSTALL_PREFIX}/lib/systemd/system-preset)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/systemd/system-preset/
        DESTINATION ${SYSTEMD_SYSTEM_PRESET_PATH})

set(SYSTEMD_SYSTEM_UNIT_PATH ${CMAKE_INSTALL_PREFIX}/lib/systemd)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/systemd/system
        DESTINATION ${SYSTEMD_SYSTEM_UNIT_PATH})

set(SYSTEMD_USER_UNIT_PATH ${CMAKE_INSTALL_PREFIX}/lib/systemd)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/systemd/user
        DESTINATION ${SYSTEMD_USER_UNIT_PATH})

set(SYSTEMD_SYSTEM_GENERATOR_PATH
    ${CMAKE_INSTALL_PREFIX}/lib/systemd/system-environment-generators)

install(
  PROGRAMS
    ${CMAKE_CURRENT_BINARY_DIR}/lib/systemd/system-environment-generators/61-linglong
  DESTINATION ${SYSTEMD_SYSTEM_GENERATOR_PATH})

install(
  PROGRAMS
    ${CMAKE_CURRENT_BINARY_DIR}/lib/systemd/user-generators/linglong-user-systemd-generator
  DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/systemd/user-generators)

# sysuser

set(SYSTEMD_SYSUSERSDIR ${CMAKE_INSTALL_PREFIX}/lib/sysusers.d)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/sysusers.d/
        DESTINATION ${SYSTEMD_SYSUSERSDIR})

# tmpfiles
set(SYSTEMD_TMPFILESDIR ${CMAKE_INSTALL_PREFIX}/lib/tmpfiles.d)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/tmpfiles.d/
        DESTINATION ${SYSTEMD_TMPFILESDIR})

# xdg
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/share/mime/packages
        DESTINATION ${CMAKE_INSTALL_DATADIR}/mime)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/applications/linyaps.desktop
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/icons/linyaps.svg
        DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)

# set linglong XDG_DATA_DIRS environtment
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/script/linglong.sh
        DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/profile.d)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/script/linglong.sh
  DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/X11/Xsession.d/
  RENAME 21linglong)

# polkit actions
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/share/polkit-1/actions/org.deepin.linglong.PackageManager1.policy
  DESTINATION ${CMAKE_INSTALL_DATADIR}/polkit-1/actions)

=== po/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright (C) 2018 Xiphos Development Team
#
# SPDX-License-Identifier: GPL-2.0-or-later

# building MO files We copy all PO files in the build dir in order to not alter
# the source tree as 'gettext_process_pot_file' rebuilds each PO file from the
# POT file. The only case a PO file is created is when a language is set in
# LINGUAS and the PO file is missing.

find_package(Gettext)

if(GETTEXT_FOUND)
  # # get a list of active translations from LINGUAS
  file(READ ${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS linguas)
  # # transform linguas string to a cmake regular list
  string(REGEX MATCHALL "[a-zA-Z_]+" langs "${linguas}")

  # copy PO files into build dir
  foreach(lang ${langs})
    set(pofile "${CMAKE_CURRENT_SOURCE_DIR}/${lang}.po")
    if(NOT EXISTS ${pofile})
      # missing PO, add a new PO file
      message(STATUS "Creating po/${lang}.po from LINGUAS.")
      # copy linyaps.pot into build dir
      file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/${GETTEXT_DOMAIN_NAME}.pot"
           DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
      # rename pot copy to ${lang}.po
      file(RENAME "${CMAKE_CURRENT_BINARY_DIR}/${GETTEXT_DOMAIN_NAME}.pot"
           "${CMAKE_CURRENT_BINARY_DIR}/${lang}.po")
      # copy new ${lang}.po into source dir
      file(COPY "${CMAKE_CURRENT_BINARY_DIR}/${lang}.po"
           DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})
    else()
      # copy existing PO file into build dir
      file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/${lang}.po"
           DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
    endif()
  endforeach(lang)

  # create and install MO files
  gettext_process_pot_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/${GETTEXT_DOMAIN_NAME}.pot ALL
    INSTALL_DESTINATION ${CMAKE_INSTALL_LOCALEDIR}
    LANGUAGES ${langs})

  add_custom_target(process-pot-file)
  get_real_target_name(TARGET linglong::ll-cli)
  get_real_target_name(BUILD_TARGET linglong::ll-builder)
  get_real_target_name(DIALOG linglong::ll-dialog)
  add_dependencies("${TARGET}" process-pot-file)
  add_dependencies("${BUILD_TARGET}" process-pot-file)
  add_dependencies("${DIALOG}" process-pot-file)

  # Custom targets for updating translation files NOTE: these targets will
  # update files in the source tree

  # target to refresh POT file
  find_program(INTLTOOL_UPDATE intltool-update)
  add_custom_target(
    pot
    COMMAND ${INTLTOOL_UPDATE} --pot --gettext-package=${GETTEXT_DOMAIN_NAME}
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/po
    COMMENT "Updating pot file.")

  # target for updating a given PO file
  foreach(language ${langs})
    add_custom_target(
      linyaps_${language}.po
      COMMAND ${GETTEXT_MSGMERGE_EXECUTABLE} --no-fuzzy-matching --backup=off --update --verbose ${language}.po
              ${GETTEXT_DOMAIN_NAME}.pot
      WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/po
      COMMENT "Updating ${language}.po file")

    # prepare command for the all PO target
    set(PO_UPDATE_ALL
        ${PO_UPDATE_ALL}
        &&
        echo
        ${language}.po:
        &&
        ${GETTEXT_MSGMERGE_EXECUTABLE}
        --no-fuzzy-matching
        --backup=off
        --update
        --verbose
        ${language}.po
        ${GETTEXT_DOMAIN_NAME}.pot)
  endforeach()

  # target for updating all PO files
  set(PO_UPDATE_ALL pwd ${PO_UPDATE_ALL})
  add_custom_target(
    po
    COMMAND ${PO_UPDATE_ALL}
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/po
    COMMENT "Updating all PO files"
    VERBATIM)
endif()

=== apps/ll-cli/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_executable(
  SOURCES
  ./src/main.cpp
  OUTPUT_NAME
  ${LINGLONG_CLI_BIN}
  LINK_LIBRARIES
  PUBLIC
  linglong::linglong)

=== apps/ll-init/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2025 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_executable(SOURCES ./src/ll-init.cpp OUTPUT_NAME ll-init LIBEXEC
                   linglong)

set(LL_INIT_TARGET)

get_real_target_name(LL_INIT_TARGET linglong::ll-init)
target_link_libraries(${LL_INIT_TARGET} PRIVATE stdc++fs)
target_link_options(${LL_INIT_TARGET} PRIVATE -static -static-libgcc
                    -static-libstdc++)

=== libs/dbus-api/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_library(
  MERGED_HEADER_PLACEMENT
  DISABLE_INSTALL
  LIBRARY_TYPE
  STATIC
  SOURCES
  # find -regex '\.\/.+\.[ch]\(pp\)?' -type f -printf '%P\n'| sort
  src/linglong/api/dbus/v1/dbus_peer.cpp
  src/linglong/api/dbus/v1/dbus_peer.h
  src/linglong/api/dbus/v1/package_manager.cpp
  src/linglong/api/dbus/v1/package_manager.h
  src/linglong/api/dbus/v1/task.cpp
  src/linglong/api/dbus/v1/task.h
  COMPILE_FEATURES
  PUBLIC
  cxx_std_17
  LINK_LIBRARIES
  PUBLIC
  Qt${QT_VERSION_MAJOR}::Core
  Qt${QT_VERSION_MAJOR}::DBus)

function(linglong_add_dbus_interface target xml basename) # include

  set_source_files_properties(${xml} NO_NAMESPACE ON)

  if(${ARGC} GREATER 3)
    set(include "${ARGV3}")
    if(include)
      set_source_files_properties(${xml} PROPERTIES INCLUDE ${include})
    endif()
  endif()

  if("${QT_VERSION_MAJOR}" STREQUAL "6")
    qt6_add_dbus_interface(INTERFACE_SOURCES ${xml} ${basename})
  else()
    set(Qt5DBus_QDBUSXML2CPP_EXECUTABLE qdbusxml2cpp)
    qt5_add_dbus_interface(INTERFACE_SOURCES ${xml} ${basename})
  endif()
  target_sources(${target} PRIVATE ${INTERFACE_SOURCES})
endfunction()

set(real_dbus_api)
get_real_target_name(real_dbus_api linglong::dbus-api)
target_include_directories(${real_dbus_api} PUBLIC ${CMAKE_CURRENT_BINARY_DIR})

linglong_add_dbus_interface(
  ${real_dbus_api}
  ${PROJECT_SOURCE_DIR}/api/dbus/org.deepin.linglong.PackageManager1.xml
  src/linglong/api/dbus/v1/gen_org_deepin_linglong_packagemanager1)

linglong_add_dbus_interface(
  ${real_dbus_api} ${PROJECT_SOURCE_DIR}/api/dbus/org.deepin.linglong.Task1.xml
  src/linglong/api/dbus/v1/gen_org_deepin_linglong_task1)

linglong_add_dbus_interface(
  ${real_dbus_api} ${PROJECT_SOURCE_DIR}/api/dbus/org.freedesktop.DBus.Peer.xml
  src/linglong/api/dbus/v1/gen_org_freedesktop_dbus_peer)

=== libs/linglong/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_library(
  MERGED_HEADER_PLACEMENT
  DISABLE_INSTALL
  LIBRARY_TYPE
  STATIC
  SOURCES
  src/linglong/builder/builder_releases.qrc
  # find -regex '\./src/.+\.[ch]\(pp\)?\(\.in\)?' -type f -printf '%P\n'| sort
  src/linglong/adaptors/package_manager/package_manager1.cpp
  src/linglong/adaptors/package_manager/package_manager1.h
  src/linglong/adaptors/task/task1.cpp
  src/linglong/adaptors/task/task1.h
  src/linglong/builder/config.cpp
  src/linglong/builder/config.h
  src/linglong/builder/linglong_builder.cpp
  src/linglong/builder/linglong_builder.h
  src/linglong/builder/printer.h
  src/linglong/builder/source_fetcher.cpp
  src/linglong/builder/source_fetcher.h
  src/linglong/cli/cli.cpp
  src/linglong/cli/cli.h
  src/linglong/cli/cli_printer.cpp
  src/linglong/cli/cli_printer.h
  src/linglong/cli/dbus_notifier.cpp
  src/linglong/cli/dbus_notifier.h
  src/linglong/cli/dummy_notifier.cpp
  src/linglong/cli/dummy_notifier.h
  src/linglong/cli/interactive_notifier.h
  src/linglong/cli/json_printer.cpp
  src/linglong/cli/json_printer.h
  src/linglong/cli/printer.h
  src/linglong/cli/terminal_notifier.cpp
  src/linglong/cli/terminal_notifier.h
  src/linglong/extension/extension.cpp
  src/linglong/package/architecture.cpp
  src/linglong/package/architecture.h
  src/linglong/package/fallback_version.cpp
  src/linglong/package/fallback_version.h
  src/linglong/package/fuzzy_reference.cpp
  src/linglong/package/fuzzy_reference.h
  src/linglong/package/layer_dir.cpp
  src/linglong/package/layer_dir.h
  src/linglong/package/layer_file.cpp
  src/linglong/package/layer_file.h
  src/linglong/package/layer_packager.cpp
  src/linglong/package/layer_packager.h
  src/linglong/package_manager/package_manager.cpp
  src/linglong/package_manager/package_manager.h
  src/linglong/package_manager/package_task.cpp
  src/linglong/package_manager/package_task.h
  src/linglong/package/reference.cpp
  src/linglong/package/reference.h
  src/linglong/package/semver.hpp
  src/linglong/package/uab_file.cpp
  src/linglong/package/uab_file.h
  src/linglong/package/uab_packager.cpp
  src/linglong/package/uab_packager.h
  src/linglong/package/version.cpp
  src/linglong/package/version.h
  src/linglong/package/versionv1.cpp
  src/linglong/package/versionv1.h
  src/linglong/package/versionv2.cpp
  src/linglong/package/versionv2.h
  src/linglong/repo/client_factory.cpp
  src/linglong/repo/client_factory.h
  src/linglong/repo/config.cpp
  src/linglong/repo/config.h
  src/linglong/repo/migrate.cpp
  src/linglong/repo/migrate.h
  src/linglong/repo/ostree_repo.cpp
  src/linglong/repo/ostree_repo.h
  src/linglong/repo/repo_cache.cpp
  src/linglong/repo/repo_cache.h
  src/linglong/runtime/container_builder.cpp
  src/linglong/runtime/container_builder.h
  src/linglong/runtime/container.cpp
  src/linglong/runtime/container.h
  src/linglong/runtime/run_context.cpp
  src/linglong/runtime/run_context.h
  TESTS
  ll-tests
  COMPILE_FEATURES
  PUBLIC
  cxx_std_17
  LINK_LIBRARIES
  PUBLIC
  rt # for shm_open and shm_unlink
  pthread
  linglong::dbus-api
  linglong::utils
  linglong::api
  PkgConfig::ostree1
  PkgConfig::systemd
  PkgConfig::ELF
  Qt${QT_VERSION_MAJOR}::Core
  Qt${QT_VERSION_MAJOR}::DBus
  LinglongRepoClientAPI
  ytj::ytj
  tl::expected
  linglong::oci-cfg-generators
  CLI11::CLI11
  ${YAML_CPP})

function(
  linglong_add_dbus_adaptor
  target
  xml
  includes
  parent_class
  basename
  classname)
  get_real_target_name(target ${target})

  if("${QT_VERSION_MAJOR}" STREQUAL "6")
    qt6_add_dbus_adaptor(DBUS_ADAPTOR_SOURCE ${xml} ${includes} ${parent_class}
                         ${basename} ${classname})
  else()
    qt5_add_dbus_adaptor(DBUS_ADAPTOR_SOURCE ${xml} ${includes} ${parent_class}
                         ${basename} ${classname})
  endif()
  # FIXME(black_desk): `qt5_add_dbus_adaptor` will use basename as include and
  # this cannot be configured at all. This is just a workaround.
  target_include_directories(${target} PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
  target_sources(${target} PRIVATE ${DBUS_ADAPTOR_SOURCE})
endfunction()

linglong_add_dbus_adaptor(
  linglong::linglong
  ${PROJECT_SOURCE_DIR}/api/dbus/org.deepin.linglong.PackageManager1.xml
  linglong/package_manager/package_manager.h
  linglong::service::PackageManager
  src/linglong/adaptors/package_manager/gen_org_deepin_linglong_packagemanager1
  OrgDeepinLinglongPackagemanager1Adaptor)

linglong_add_dbus_adaptor(
  linglong::linglong
  ${PROJECT_SOURCE_DIR}/api/dbus/org.deepin.linglong.Task1.xml
  linglong/package_manager/package_task.h
  linglong::service::PackageTask
  src/linglong/adaptors/task/gen_org_deepin_linglong_task1
  OrgDeepinLinglongTask1Adaptor)

=== libs/oci-cfg-generators/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_library(
  MERGED_HEADER_PLACEMENT
  DISABLE_INSTALL
  LIBRARY_TYPE
  STATIC
  SOURCES
  # find -regex '\.\/.+\.[ch]\(pp\)?' -type f -printf '%P\n'| sort
  src/linglong/oci-cfg-generators/container_cfg_builder.cpp
  src/linglong/oci-cfg-generators/container_cfg_builder.h
  COMPILE_FEATURES
  PUBLIC
  cxx_std_17
  LINK_LIBRARIES
  PUBLIC
  linglong::ocppi
  linglong::api
  )

get_real_target_name(GEN linglong::oci-cfg-generators)
target_include_directories(${GEN} PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/src/linglong/oci-cfg-generators ${CMAKE_SOURCE_DIR}/apps/uab/header/src)

=== libs/ocppi/CMakeLists.txt ===
option(OCPPI_WITH_SPDLOG "Build ocppi with spdlog or not." OFF)

if(OCPPI_WITH_SPDLOG)
  set(OCPPI_SPDLOG_VERSION 1.3.1) # debian buster
  list(APPEND OCPPI_COMPILE_OPTIONS PUBLIC -DOCPPI_WITH_SPDLOG)
  list(APPEND OCPPI_LINK_LIBRARIES PUBLIC spdlog::spdlog)
  list(APPEND OCPPI_DEPENDENCIES PUBLIC "spdlog 1.3.1 REQUIRED")
endif()

if(CMAKE_VERSION LESS 3.14)
  message("CPM.cmake disabled")
else()
  if(OCPPI_WITH_SPDLOG)
    CPMFindPackage(
      NAME spdlog
      VERSION ${OCPPI_SPDLOG_VERSION}
      GITHUB_REPOSITORY "gabime/spdlog"
      GIT_TAG "v1.3.1"
      GIT_SHALLOW ON
      EXCLUDE_FROM_ALL ON
      OPTIONS
        "CMAKE_POSITION_INDEPENDENT_CODE ON" # NOTE:
                                             # https://github.com/gabime/spdlog/issues/1190
    )
  endif()
endif()

list(APPEND OCPPI_LINK_LIBRARIES PUBLIC tl::expected)
list(APPEND OCPPI_DEPENDENCIES PUBLIC "tl-expected 1.0.0 REQUIRED")

list(APPEND OCPPI_LINK_LIBRARIES PUBLIC nlohmann_json::nlohmann_json)
list(APPEND OCPPI_DEPENDENCIES PUBLIC "nlohmann_json 3.5.0 REQUIRED")

set(OCPPI_OCI_RUNTIME_SPEC_MIN "1.0.0")
set(OCPPI_OCI_RUNTIME_SPEC_MAX "1.1.0")

pfl_add_library(
  DISABLE_INSTALL
  LIBRARY_TYPE
  STATIC
  OUTPUT_NAME
  ocppi
  EXAMPLES
  parse-config
  using-crun
  with-logger
  LINK_LIBRARIES
  ${OCPPI_LINK_LIBRARIES}
  PUBLIC
  stdc++fs
  COMPILE_FEATURES
  PUBLIC
  cxx_std_17
  COMPILE_OPTIONS
  ${OCPPI_COMPILE_OPTIONS}
  DEPENDENCIES
  ${OCPPI_DEPENDENCIES}
  SOURCES
  # find -regex '\./src/.+\.[ch]\(pp\)?(\.in)?' -type f -printf '%P\n'| sort
  include/ocppi/cli/CLI.hpp
  include/ocppi/cli/CommandFailedError.hpp
  include/ocppi/cli/CommonCLI.hpp
  include/ocppi/cli/crun/Crun.hpp
  include/ocppi/cli/ExecutableNotFoundError.hpp
  include/ocppi/cli/runc/Runc.hpp
  include/ocppi/cli/youki/Youki.hpp
  include/ocppi/configure.hpp.in
  include/ocppi/InvalidArgumentError.hpp
  include/ocppi/runtime/config/types/Anet.hpp
  include/ocppi/runtime/config/types/BlockIODeviceThrottle.hpp
  include/ocppi/runtime/config/types/BlockIODeviceWeight.hpp
  include/ocppi/runtime/config/types/BlockIO.hpp
  include/ocppi/runtime/config/types/BoottimeClass.hpp
  include/ocppi/runtime/config/types/Capabilities.hpp
  include/ocppi/runtime/config/types/CappedCPU.hpp
  include/ocppi/runtime/config/types/CappedMemory.hpp
  include/ocppi/runtime/config/types/Class.hpp
  include/ocppi/runtime/config/types/Config.hpp
  include/ocppi/runtime/config/types/ConsoleSize.hpp
  include/ocppi/runtime/config/types/DeviceCgroup.hpp
  include/ocppi/runtime/config/types/FluffyCPU.hpp
  include/ocppi/runtime/config/types/FluffyMemory.hpp
  include/ocppi/runtime/config/types/Generators.hpp
  include/ocppi/runtime/config/types/helper.hpp
  include/ocppi/runtime/config/types/Hook.hpp
  include/ocppi/runtime/config/types/Hooks.hpp
  include/ocppi/runtime/config/types/HugepageLimit.hpp
  include/ocppi/runtime/config/types/Hyperv.hpp
  include/ocppi/runtime/config/types/Hypervisor.hpp
  include/ocppi/runtime/config/types/IdMapping.hpp
  include/ocppi/runtime/config/types/IdType.hpp
  include/ocppi/runtime/config/types/Image.hpp
  include/ocppi/runtime/config/types/IntelRdt.hpp
  include/ocppi/runtime/config/types/IoPriority.hpp
  include/ocppi/runtime/config/types/Kernel.hpp
  include/ocppi/runtime/config/types/LinuxDevice.hpp
  include/ocppi/runtime/config/types/Linux.hpp
  include/ocppi/runtime/config/types/LinuxResources.hpp
  include/ocppi/runtime/config/types/Mount.hpp
  include/ocppi/runtime/config/types/NamespaceReference.hpp
  include/ocppi/runtime/config/types/NamespaceType.hpp
  include/ocppi/runtime/config/types/NetworkInterfacePriority.hpp
  include/ocppi/runtime/config/types/PersonalityDomain.hpp
  include/ocppi/runtime/config/types/Personality.hpp
  include/ocppi/runtime/config/types/Pids.hpp
  include/ocppi/runtime/config/types/Process.hpp
  include/ocppi/runtime/config/types/PurpleCPU.hpp
  include/ocppi/runtime/config/types/PurpleMemory.hpp
  include/ocppi/runtime/config/types/Rdma.hpp
  include/ocppi/runtime/config/types/ResourcesNetwork.hpp
  include/ocppi/runtime/config/types/Rlimit.hpp
  include/ocppi/runtime/config/types/RootfsPropagation.hpp
  include/ocppi/runtime/config/types/Root.hpp
  include/ocppi/runtime/config/types/RootImageFormat.hpp
  include/ocppi/runtime/config/types/SchedulerFlag.hpp
  include/ocppi/runtime/config/types/Scheduler.hpp
  include/ocppi/runtime/config/types/SchedulerPolicy.hpp
  include/ocppi/runtime/config/types/SeccompAction.hpp
  include/ocppi/runtime/config/types/SeccompArch.hpp
  include/ocppi/runtime/config/types/SeccompFlag.hpp
  include/ocppi/runtime/config/types/Seccomp.hpp
  include/ocppi/runtime/config/types/SeccompOperators.hpp
  include/ocppi/runtime/config/types/Solaris.hpp
  include/ocppi/runtime/config/types/Storage.hpp
  include/ocppi/runtime/config/types/SyscallArg.hpp
  include/ocppi/runtime/config/types/Syscall.hpp
  include/ocppi/runtime/config/types/TimeOffsets.hpp
  include/ocppi/runtime/config/types/User.hpp
  include/ocppi/runtime/config/types/Vm.hpp
  include/ocppi/runtime/config/types/WindowsDevice.hpp
  include/ocppi/runtime/config/types/Windows.hpp
  include/ocppi/runtime/config/types/WindowsNetwork.hpp
  include/ocppi/runtime/config/types/WindowsResources.hpp
  include/ocppi/runtime/config/types/ZosDevice.hpp
  include/ocppi/runtime/config/types/Zos.hpp
  include/ocppi/runtime/configure.hpp.in
  include/ocppi/runtime/ContainerID.hpp
  include/ocppi/runtime/CreateOption.hpp
  include/ocppi/runtime/DeleteOption.hpp
  include/ocppi/runtime/ExecOption.hpp
  include/ocppi/runtime/FeaturesOption.hpp
  include/ocppi/runtime/features/types/Apparmor.hpp
  include/ocppi/runtime/features/types/Cgroup.hpp
  include/ocppi/runtime/features/types/Features.hpp
  include/ocppi/runtime/features/types/Generators.hpp
  include/ocppi/runtime/features/types/helper.hpp
  include/ocppi/runtime/features/types/IntelRdt.hpp
  include/ocppi/runtime/features/types/Linux.hpp
  include/ocppi/runtime/features/types/NamespaceType.hpp
  include/ocppi/runtime/features/types/SeccompAction.hpp
  include/ocppi/runtime/features/types/SeccompArch.hpp
  include/ocppi/runtime/features/types/SeccompFlag.hpp
  include/ocppi/runtime/features/types/Seccomp.hpp
  include/ocppi/runtime/features/types/SeccompOperators.hpp
  include/ocppi/runtime/features/types/Selinux.hpp
  include/ocppi/runtime/GlobalOption.hpp
  include/ocppi/runtime/KillOption.hpp
  include/ocppi/runtime/ListOption.hpp
  include/ocppi/runtime/RunOption.hpp
  include/ocppi/runtime/Runtime.hpp
  include/ocppi/runtime/Signal.hpp
  include/ocppi/runtime/SpecRuntime.hpp
  include/ocppi/runtime/StartOption.hpp
  include/ocppi/runtime/StateOption.hpp
  include/ocppi/runtime/state/types/Generators.hpp
  include/ocppi/runtime/state/types/helper.hpp
  include/ocppi/runtime/state/types/State.hpp
  include/ocppi/runtime/state/types/Status.hpp
  include/ocppi/types/ContainerListItem.hpp
  include/ocppi/types/Generators.hpp
  include/ocppi/types/helper.hpp
  src/ocppi/cli/CLI.cpp
  src/ocppi/cli/CommandFailedError.cpp
  src/ocppi/cli/CommonCLI.cpp
  src/ocppi/cli/crun/Crun.cpp
  src/ocppi/cli/ExecutableNotFoundError.cpp
  src/ocppi/cli/Process.cpp
  src/ocppi/cli/Process.hpp
  src/ocppi/cli/runc/Runc.cpp
  src/ocppi/cli/youki/Youki.cpp
  src/ocppi/configure.cpp
  src/ocppi/InvalidArgumentError.cpp
  src/ocppi/runtime/configure.cpp
  src/ocppi/runtime/ContainerID.cpp
  src/ocppi/runtime/CreateOption.cpp
  src/ocppi/runtime/DeleteOption.cpp
  src/ocppi/runtime/FeaturesOption.cpp
  src/ocppi/runtime/GlobalOption.cpp
  src/ocppi/runtime/KillOption.cpp
  src/ocppi/runtime/RunOption.cpp
  src/ocppi/runtime/Runtime.cpp
  src/ocppi/runtime/Signal.cpp
  src/ocppi/runtime/StartOption.cpp
  src/ocppi/runtime/StateOption.cpp)

=== libs/utils/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_library(
  MERGED_HEADER_PLACEMENT
  DISABLE_INSTALL
  LIBRARY_TYPE
  STATIC
  SOURCES
  # find -regex '\.\/*.+\.[ch]\(pp\)?\(.in\)?' -type f -printf '%P\n'| sort
  src/linglong/utils/command/env.cpp
  src/linglong/utils/command/env.h
  src/linglong/utils/command/cmd.cpp
  src/linglong/utils/command/cmd.h
  src/linglong/utils/command/ocppi-helper.cpp
  src/linglong/utils/command/ocppi-helper.h
  src/linglong/utils/dbus/log.cpp
  src/linglong/utils/dbus/log.h
  src/linglong/utils/dbus/properties_forwarder.cpp
  src/linglong/utils/dbus/properties_forwarder.h
  src/linglong/utils/dbus/register.cpp
  src/linglong/utils/dbus/register.h
  src/linglong/utils/error/details/error_impl.cpp
  src/linglong/utils/error/details/error_impl.h
  src/linglong/utils/error/error.cpp
  src/linglong/utils/error/error.h
  src/linglong/utils/finally/finally.cpp
  src/linglong/utils/finally/finally.h
  src/linglong/utils/gettext.h
  src/linglong/utils/global/initialize.cpp
  src/linglong/utils/global/initialize.h
  src/linglong/utils/log/formatter.cpp
  src/linglong/utils/log/formatter.h
  src/linglong/utils/log/log.cpp
  src/linglong/utils/log/log.h
  src/linglong/utils/overlayfs.cpp
  src/linglong/utils/overlayfs.h
  src/linglong/utils/packageinfo_handler.cpp
  src/linglong/utils/packageinfo_handler.h
  src/linglong/utils/serialize/json.cpp
  src/linglong/utils/serialize/json.h
  src/linglong/utils/serialize/yaml.cpp
  src/linglong/utils/serialize/yaml.h
  src/linglong/utils/transaction.cpp
  src/linglong/utils/transaction.h
  src/linglong/utils/file.cpp
  src/linglong/utils/file.h
  src/linglong/utils/xdg/directory.h
  src/linglong/utils/gkeyfile_wrapper.h
  src/linglong/utils/hooks.cpp
  src/linglong/utils/hooks.h
  src/linglong/utils/bash_quote.h
  src/linglong/utils/bash_command_helper.h
  COMPILE_FEATURES
  PUBLIC
  cxx_std_17
  LINK_LIBRARIES
  PUBLIC
  Qt${QT_VERSION_MAJOR}::Core
  Qt${QT_VERSION_MAJOR}::DBus
  PkgConfig::glib2
  fmt::fmt
  tl::expected
  ytj::ytj
  linglong::ocppi
  linglong::api)

=== apps/uab/header/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")

# TODO: if erofsfuse and libdeflate provides .pc file or config.cmake, change it
# to pkg_search_modules/find_package

find_library(static_liberofsfuse "erofsfuse")
if("${static_liberofsfuse}" STREQUAL "static_liberofsfuse-NOTFOUND")
  message(FATAL_ERROR "liberofsfuse.a not found.")
endif()

get_filename_component(EROFSFUSE_ABS_FILE ${static_liberofsfuse} ABSOLUTE)
message(STATUS "found liberofsfuse.a: ${ABS_FILE}")

find_library(static_libdeflate "deflate")
if("${static_libdeflate}" STREQUAL "static_libdeflate-NOTFOUND")
  message(FATAL_ERROR "libdeflate.a not found")
endif()

get_filename_component(LIBDEFLATE_ABS_FILE ${static_libdeflate} ABSOLUTE)
message(STATUS "found libdeflate.a: ${LIBDEFLATE_ABS_FILE}")

pkg_search_module(lz4 REQUIRED IMPORTED_TARGET liblz4)
pkg_search_module(lzma REQUIRED IMPORTED_TARGET liblzma)
pkg_search_module(FUSE3 REQUIRED IMPORTED_TARGET fuse3)
pkg_search_module(SELINUX REQUIRED IMPORTED_TARGET libselinux)
pkg_search_module(ZSTD REQUIRED IMPORTED_TARGET libzstd)
pkg_search_module(PCRE2_8 REQUIRED IMPORTED_TARGET libpcre2-8)

pfl_add_executable(
  DISABLE_INSTALL
  SOURCES
  ./src/main.cpp
  ./src/sha256.h
  ./src/light_elf.h
  ./src/utils.h
  OUTPUT_NAME
  uab-header
  LINK_LIBRARIES
  PRIVATE
  linglong::api
  nlohmann_json::nlohmann_json
  PkgConfig::SELINUX
  PkgConfig::ZSTD
  PkgConfig::lz4
  PkgConfig::lzma
  PkgConfig::PCRE2_8
  PkgConfig::FUSE3
  ${EROFSFUSE_ABS_FILE}
  ${LIBDEFLATE_ABS_FILE}
  stdc++fs)

set(UAB_HEADER_TARGET)
get_real_target_name(UAB_HEADER_TARGET linglong::header)

target_link_options(${UAB_HEADER_TARGET} PRIVATE -static -static-libgcc
                    -static-libstdc++)

if(${AGGRESSIVE_UAB_SIZE})
  message(STATUS "minify size of uab header aggressively")
  target_compile_options(
    ${UAB_HEADER_TARGET} PRIVATE -Os -fno-asynchronous-unwind-tables -fno-rtti
                                 -fdata-sections -ffunction-sections -flto=auto)

  target_link_options(
    ${UAB_HEADER_TARGET} PRIVATE
    -Wl,--gc-sections,--as-needed,--strip-all,--exclude-libs,ALL -flto=auto)
endif()

include(GNUInstallDirs)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/uab-header
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/linglong/builder/uab)

=== apps/uab/loader/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_executable(
  DISABLE_INSTALL
  SOURCES
  ./src/main.cpp
  OUTPUT_NAME
  uab-loader
  LINK_LIBRARIES
  PRIVATE
  linglong::api
  linglong::oci-cfg-generators)

set(UAB_LOADER_TARGET)
get_real_target_name(UAB_LOADER_TARGET linglong::loader)

target_link_options(${UAB_LOADER_TARGET} PRIVATE -static -static-libgcc
                    -static-libstdc++)

if(${AGGRESSIVE_UAB_SIZE})
  message(STATUS "minify size of uab loader aggressively")
  target_compile_options(
    ${UAB_LOADER_TARGET} PRIVATE -Os -fno-asynchronous-unwind-tables -fno-rtti
                                 -fdata-sections -ffunction-sections -flto=auto)

  target_link_options(
    ${UAB_LOADER_TARGET} PRIVATE
    -Wl,--gc-sections,--as-needed,--strip-all,--exclude-libs,ALL -flto=auto)
endif()

include(GNUInstallDirs)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/uab-loader
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/linglong/builder/uab)

=== debian/changelog ===
linglong (1.9.13-1) unstable; urgency=medium

  * fix: fix env is cleared by `env -i`.
  * refactor: simplify container entrypoint generation.
  * feat: enable git submodule fetching with environment variable control.
  * feat: add mirror enable/disable functionality for repositories.
  * feat: add no-clean-objects option for remove command.

 -- dengbo <dengbo@deepin.org>  Fri, 19 Sep 2025 16:03:17 +0800

linglong (1.9.12-1) unstable; urgency=medium

  * release 1.9.12-1.

 -- dengbo <dengbo@deepin.org>  Fri, 19 Sep 2025 11:12:40 +0800

linglong (1.9.11-1) unstable; urgency=medium

  * release 1.9.11-1.

 -- dengbo <dengbo@deepin.org>  Fri, 05 Sep 2025 10:29:45 +0800

linglong (1.9.10-1) unstable; urgency=medium

  * release 1.9.10-1.

 -- dengbo <dengbo@deepin.org>  Fri, 22 Aug 2025 12:38:12 +0800

=== debian/control ===
Source: linglong
Section: admin
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: cmake,
               debhelper-compat (= 12),
               intltool,
               libcli11-dev (>= 2.4.1) | hello,
               libcurl4-openssl-dev,
               libdeflate-dev,
               libelf-dev,
               libexpected-dev (>= 1.0.0~dfsg-2~bpo10+1) | hello,
               libfuse3-dev,
               libglib2.0-dev,
               libgmock-dev,
               libgtest-dev,
               liblz4-dev,
               liblzma-dev,
               libostree-dev,
               libpcre2-dev,
               libselinux1-dev,
               libssl-dev,
               libsystemd-dev,
               libyaml-cpp-dev (>= 0.6.2),
               libzstd-dev,
               nlohmann-json3-dev (>= 3.5.0),
               pkg-config,
               qt6-base-dev | qtbase5-dev,
               qt6-base-private-dev | qtbase5-private-dev,
               systemd,
               zlib1g-dev
Standards-Version: 4.1.3
Homepage: http://www.deepin.org

Package: linglong-bin
Architecture: any
Depends: desktop-file-utils,
         libglib2.0-bin,
         linglong-box | crun,
         shared-mime-info,
         pkexec | policykit-1,
         erofs-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: linglong-dbus-proxy
Conflicts: linglong-dbus-proxy
Recommends: erofsfuse
Description: Linglong package manager.
 Linglong package management command line tool.

Package: linglong-builder
Architecture: any
Depends: erofs-utils,
         fuse-overlayfs,
         git,
         linglong-bin,
         linglong-box | crun,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: linglong-loader
Suggests: devscripts
Description: Linglong application building tools.
 ll-builder is a tool that makes it easy to build applications and dependencies.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --buildsystem=cmake

EXTRA_OPTION = -DCPM_LOCAL_PACKAGES_ONLY=ON -DLINGLONG_VERSION=$(DEB_VERSION_UPSTREAM) -DENABLE_LINGLONG_INSTALLER=ON -DLINGLONG_EXPORT_PATH=apps/share

override_dh_auto_configure:
	dh_auto_configure --  ${EXTRA_OPTION}  ${DH_AUTO_ARGS}

# https://sources.debian.org/src/amavisd-new/1:2.13.0-3/debian/rules/?hl=10#L10
execute_after_dh_installinit:
	dh_installsysusers # this is needed until dh compat 14

## linglong 1.10.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -257,6 +257,9 @@
 
   while(true)
     find_package(Qt6 COMPONENTS Core DBus)
+    if(Qt6_FOUND AND Qt6_VERSION VERSION_GREATER_EQUAL "6.10")
+      find_package(Qt6 COMPONENTS DBusPrivate)
+    endif()
     if(Qt6_FOUND)
       set(QT_VERSION_MAJOR "6")
       break()

=== debian/changelog ===
linglong (1.10.2-1) unstable; urgency=medium

  * release 1.10.2-1.

 -- dengbo <dengbo@deepin.org>  Fri, 14 Nov 2025 14:58:28 +0800

linglong (1.10.1-1) unstable; urgency=medium

  * release 1.10.1-1.

 -- dengbo <dengbo@deepin.org>  Fri, 31 Oct 2025 13:16:07 +0800

=== debian/control ===
--- 
+++ 
@@ -28,7 +28,8 @@
                qt6-base-dev | qtbase5-dev,
                qt6-base-private-dev | qtbase5-private-dev,
                systemd,
-               zlib1g-dev
+               zlib1g-dev,
+               libcap-dev
 Standards-Version: 4.1.3
 Homepage: http://www.deepin.org
 
@@ -55,6 +56,7 @@
          git,
          linglong-bin,
          linglong-box | crun,
+         uidmap
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: linglong-loader
